diff --git a/roms/ipxe/src/include/ipxe/list.h b/roms/ipxe/src/include/ipxe/list.h
index ab4c119dd775e93dfc003d757a32..0d0973077e88efc803f6b40dbe7f 100644
--- a/roms/ipxe/src/include/ipxe/list.h
+++ b/roms/ipxe/src/include/ipxe/list.h
@@ -42,9 +42,9 @@ struct list_head {
  *
  * @v list		List head
  */
-#define INIT_LIST_HEAD( list ) do {			\
-	(list)->next = (list);				\
-	(list)->prev = (list);				\
+#define INIT_LIST_HEAD( list ) do {				\
+	(list)->next = (list);					\
+	(list)->prev = (list);					\
 	} while ( 0 )
 
 /**
@@ -52,43 +52,35 @@ struct list_head {
  *
  * @v list		List entry or head
  */
-#define list_check( list ) ( {				\
-	assert ( (list) != NULL );			\
-	assert ( (list)->prev != NULL );		\
-	assert ( (list)->next != NULL );		\
-	assert ( (list)->next->prev == (list) );	\
-	assert ( (list)->prev->next == (list) );	\
+#define list_check( list ) ( {					\
+	assert ( (list) != NULL );				\
+	assert ( (list)->prev != NULL );			\
+	assert ( (list)->next != NULL );			\
+	assert ( (list)->next->prev == (list) );		\
+	assert ( (list)->prev->next == (list) );		\
 	} )
 
-/**
- * Insert a list entry between two known consecutive entries
- *
- * @v new		New list entry
- * @v prev		Previous list entry
- * @v next		Next list entry
- */
-static inline void __list_add ( struct list_head *new,
-				struct list_head *prev,
-				struct list_head *next ) {
-	next->prev = new;
-	new->next = next;
-	new->prev = prev;
-	prev->next = new;
-}
-
 /**
  * Add a new entry to the head of a list
  *
  * @v new		New entry to be added
  * @v head		List head, or entry after which to add the new entry
  */
-static inline void list_add ( struct list_head *new, struct list_head *head ) {
-	__list_add ( new, head, head->next );
-}
-#define list_add( new, head ) do {			\
-	list_check ( (head) );				\
-	list_add ( (new), (head) );			\
+#define list_add( new, head ) do {				\
+	list_check ( (head) );					\
+	extern_list_add ( (new), (head) );			\
 	} while ( 0 )
+static inline void inline_list_add ( struct list_head *new,
+				     struct list_head *head ) {
+	struct list_head *prev = head;
+	struct list_head *next = head->next;
+	next->prev = (new);
+	(new)->next = next;
+	(new)->prev = prev;
+	prev->next = (new);
+}
+extern void extern_list_add ( struct list_head *new,
+			      struct list_head *head );
 
 /**
  * Add a new entry to the tail of a list
@@ -96,26 +88,21 @@ static inline void list_add ( struct list_head *new, struct list_head *head ) {
  * @v new		New entry to be added
  * @v head		List head, or entry before which to add the new entry
  */
-static inline void list_add_tail ( struct list_head *new,
-				   struct list_head *head ) {
-	__list_add ( new, head->prev, head );
-}
-#define list_add_tail( new, head ) do {			\
-	list_check ( (head) );				\
-	list_add_tail ( (new), (head) );		\
+#define list_add_tail( new, head ) do {				\
+	list_check ( (head) );					\
+	extern_list_add_tail ( (new), (head) );			\
 	} while ( 0 )
-
-/**
- * Delete a list entry between two known consecutive entries
- *
- * @v prev		Previous list entry
- * @v next		Next list entry
- */
-static inline void __list_del ( struct list_head *prev,
-				struct list_head *next ) {
-	next->prev = prev;
-	prev->next = next;
+static inline void inline_list_add_tail ( struct list_head *new,
+					  struct list_head *head ) {
+	struct list_head *prev = head->prev;
+	struct list_head *next = head;
+	next->prev = (new);
+	(new)->next = next;
+	(new)->prev = prev;
+	prev->next = (new);
 }
+extern void extern_list_add_tail ( struct list_head *new,
+				   struct list_head *head );
 
 /**
  * Delete an entry from a list
@@ -125,25 +112,199 @@ static inline void __list_del ( struct list_head *prev,
  * Note that list_empty() on entry does not return true after this;
  * the entry is in an undefined state.
  */
-static inline void list_del ( struct list_head *list ) {
-	__list_del ( list->prev, list->next );
-}
-#define list_del( list ) do {				\
-	list_check ( (list) );				\
-	list_del ( (list) );				\
+#define list_del( list ) do {					\
+	list_check ( (list) );					\
+	inline_list_del ( (list) );				\
 	} while ( 0 )
+static inline void inline_list_del ( struct list_head *list ) {
+	struct list_head *next = (list)->next;
+	struct list_head *prev = (list)->prev;
+	next->prev = prev;
+	prev->next = next;
+}
+extern void extern_list_del ( struct list_head *list );
 
 /**
  * Test whether a list is empty
  *
  * @v list		List head
  */
-static inline int list_empty ( const struct list_head *list ) {
+#define list_empty( list ) ( {					\
+	list_check ( (list) );					\
+	inline_list_empty ( (list) ); } )
+static inline int inline_list_empty ( const struct list_head *list ) {
 	return ( list->next == list );
 }
-#define list_empty( list ) ( {				\
-	list_check ( (list) );				\
-	list_empty ( (list) ); } )
+extern int extern_list_empty ( const struct list_head *list );
+
+/**
+ * Test whether a list has just one entry
+ *
+ * @v list		List to test
+ */
+#define list_is_singular( list ) ( {				\
+	list_check ( (list) );					\
+	inline_list_is_singular ( (list) ); } )
+static inline int inline_list_is_singular ( const struct list_head *list ) {
+	return ( ( ! list_empty ( list ) ) && ( list->next == list->prev ) );
+}
+extern int extern_list_is_singular ( const struct list_head *list );
+
+/**
+ * Test whether an entry is the last entry in list
+ *
+ * @v list		List entry to test
+ * @v head		List head
+ */
+#define list_is_last( list, head ) ( {				\
+	list_check ( (list) );					\
+	list_check ( (head) );					\
+	inline_list_is_last ( (list), (head) ); } )
+static inline int inline_list_is_last ( const struct list_head *list,
+					const struct list_head *head ) {
+	return ( list->next == head );
+}
+extern int extern_list_is_last ( const struct list_head *list,
+				 const struct list_head *head );
+
+/**
+ * Cut a list into two
+ *
+ * @v new		A new list to contain all removed entries
+ * @v list		An existing list
+ * @v entry		An entry within the existing list
+ *
+ * All entries from @c list up to and including @c entry are moved to
+ * @c new, which should be an empty list.  @c entry may be equal to @c
+ * list, in which case no entries are moved.
+ */
+#define list_cut_position( new, list, entry ) do {		\
+	list_check ( (new) );					\
+	assert ( list_empty ( (new) ) );			\
+	list_check ( (list) );					\
+	list_check ( (entry) );					\
+	extern_list_cut_position ( (new), (list), (entry) );	\
+	} while ( 0 )
+static inline void inline_list_cut_position ( struct list_head *new,
+					      struct list_head *list,
+					      struct list_head *entry ) {
+	struct list_head *first = entry->next;
+
+	if ( list != entry ) {
+		new->next = list->next;
+		new->next->prev = new;
+		new->prev = entry;
+		new->prev->next = new;
+		list->next = first;
+		list->next->prev = list;
+	}
+}
+extern void extern_list_cut_position ( struct list_head *new,
+				       struct list_head *list,
+				       struct list_head *entry );
+
+/**
+ * Move all entries from one list into another list
+ *
+ * @v list		List of entries to add
+ * @v entry		Entry after which to add the new entries
+ *
+ * All entries from @c list are inserted after @c entry.  Note that @c
+ * list is left in an undefined state; use @c list_splice_init() if
+ * you want @c list to become an empty list.
+ */
+#define list_splice( list, entry ) do {				\
+	list_check ( (list) );					\
+	list_check ( (entry) );					\
+	extern_list_splice ( (list), (entry) );			\
+	} while ( 0 )
+static inline void inline_list_splice ( const struct list_head *list,
+					struct list_head *entry ) {
+	struct list_head *first = list->next;
+	struct list_head *last = list->prev;
+
+	if ( ! list_empty ( list ) ) {
+		last->next = entry->next;
+		last->next->prev = last;
+		first->prev = entry;
+		first->prev->next = first;
+	}
+}
+extern void extern_list_splice ( const struct list_head *list,
+				 struct list_head *entry );
+
+/**
+ * Move all entries from one list into another list
+ *
+ * @v list		List of entries to add
+ * @v entry		Entry before which to add the new entries
+ *
+ * All entries from @c list are inserted before @c entry.  Note that @c
+ * list is left in an undefined state; use @c list_splice_tail_init() if
+ * you want @c list to become an empty list.
+ */
+#define list_splice_tail( list, entry ) do {			\
+	list_check ( (list) );					\
+	list_check ( (entry) );					\
+	extern_list_splice_tail ( (list), (entry) );		\
+	} while ( 0 )
+static inline void inline_list_splice_tail ( const struct list_head *list,
+					     struct list_head *entry ) {
+	struct list_head *first = list->next;
+	struct list_head *last = list->prev;
+
+	if ( ! list_empty ( list ) ) {
+		first->prev = entry->prev;
+		first->prev->next = first;
+		last->next = entry;
+		last->next->prev = last;
+	}
+}
+extern void extern_list_splice_tail ( const struct list_head *list,
+				      struct list_head *entry );
+
+/**
+ * Move all entries from one list into another list and reinitialise empty list
+ *
+ * @v list		List of entries to add
+ * @v entry		Entry after which to add the new entries
+ *
+ * All entries from @c list are inserted after @c entry.
+ */
+#define list_splice_init( list, entry ) do {			\
+	list_check ( (list) );					\
+	list_check ( (entry) );					\
+	extern_list_splice_init ( (list), (entry) );		\
+	} while ( 0 )
+static inline void inline_list_splice_init ( struct list_head *list,
+					     struct list_head *entry ) {
+	list_splice ( list, entry );
+	INIT_LIST_HEAD ( list );
+}
+extern void extern_list_splice_init ( struct list_head *list,
+				      struct list_head *entry );
+
+/**
+ * Move all entries from one list into another list and reinitialise empty list
+ *
+ * @v list		List of entries to add
+ * @v entry		Entry before which to add the new entries
+ *
+ * All entries from @c list are inserted before @c entry.
+ */
+#define list_splice_tail_init( list, entry ) do {		\
+	list_check ( (list) );					\
+	list_check ( (entry) );					\
+	extern_list_splice_tail_init ( (list), (entry) );	\
+	} while ( 0 )
+
+static inline void inline_list_splice_tail_init ( struct list_head *list,
+						  struct list_head *entry ) {
+	list_splice_tail ( list, entry );
+	INIT_LIST_HEAD ( list );
+}
+extern void extern_list_splice_tail_init ( struct list_head *list,
+					   struct list_head *entry );
 
 /**
  * Get the container of a list entry
@@ -153,8 +314,8 @@ static inline int list_empty ( const struct list_head *list ) {
  * @v member		Name of list field within containing type
  * @ret container	Containing object
  */
-#define list_entry( list, type, member ) ( {		\
-	list_check ( (list) );				\
+#define list_entry( list, type, member ) ( {			\
+	list_check ( (list) );					\
 	container_of ( list, type, member ); } )
 
 /**
@@ -165,11 +326,36 @@ static inline int list_empty ( const struct list_head *list ) {
  * @v member		Name of list field within containing type
  * @ret first		First list entry, or NULL
  */
-#define list_first_entry( list, type, member )		\
-	( list_empty ( (list) ) ?			\
-	  ( type * ) NULL :				\
+#define list_first_entry( list, type, member )			\
+	( list_empty ( (list) ) ?				\
+	  ( type * ) NULL :					\
 	  list_entry ( (list)->next, type, member ) )
 
+/**
+ * Get the container of the last entry in a list
+ *
+ * @v list		List head
+ * @v type		Containing type
+ * @v member		Name of list field within containing type
+ * @ret first		First list entry, or NULL
+ */
+#define list_last_entry( list, type, member )			\
+	( list_empty ( (list) ) ?				\
+	  ( type * ) NULL :					\
+	  list_entry ( (list)->prev, type, member ) )
+
+/**
+ * Iterate over a list
+ *
+ * @v pos		Iterator
+ * @v head		List head
+ */
+#define list_for_each( pos, head )					      \
+	for ( list_check ( (head) ),					      \
+	      pos = (head)->next;					      \
+	      pos != (head);						      \
+	      pos = (pos)->next )
+
 /**
  * Iterate over entries in a list
  *
@@ -212,4 +398,75 @@ static inline int list_empty ( const struct list_head *list ) {
 	      pos = tmp,						      \
 	      tmp = list_entry ( tmp->member.next, typeof ( *tmp ), member ) )
 
+/**
+ * Iterate over entries in a list, starting after current position
+ *
+ * @v pos		Iterator
+ * @v head		List head
+ * @v member		Name of list field within iterator's type
+ */
+#define list_for_each_entry_continue( pos, head, member )		      \
+	for ( list_check ( (head) ),					      \
+	      pos = list_entry ( pos->member.next, typeof ( *pos ), member ); \
+	      &pos->member != (head);					      \
+	      pos = list_entry ( pos->member.next, typeof ( *pos ), member ) )
+
+/**
+ * Iterate over entries in a list in reverse, starting after current position
+ *
+ * @v pos		Iterator
+ * @v head		List head
+ * @v member		Name of list field within iterator's type
+ */
+#define list_for_each_entry_continue_reverse( pos, head, member )	      \
+	for ( list_check ( (head) ),					      \
+	      pos = list_entry ( pos->member.prev, typeof ( *pos ), member ); \
+	      &pos->member != (head);					      \
+	      pos = list_entry ( pos->member.prev, typeof ( *pos ), member ) )
+
+/**
+ * Test if list contains a specified entry
+ *
+ * @v entry		Entry
+ * @v head		List head
+ * @ret present		List contains specified entry
+ */
+#define list_contains( entry, head ) ( {			\
+	list_check ( (head) );					\
+	list_check ( (entry) );					\
+	extern_list_contains ( (entry), (head) ); } )
+static inline int inline_list_contains ( struct list_head *entry,
+					 struct list_head *head ) {
+	struct list_head *tmp;
+
+	list_for_each ( tmp, head ) {
+		if ( tmp == entry )
+			return 1;
+	}
+	return 0;
+}
+extern int extern_list_contains ( struct list_head *entry,
+				  struct list_head *head );
+
+/**
+ * Test if list contains a specified entry
+ *
+ * @v entry		Entry
+ * @v head		List head
+ * @ret present		List contains specified entry
+ */
+#define list_contains_entry( entry, head, member )		\
+	list_contains ( &(entry)->member, (head) )
+
+/**
+ * Check list contains a specified entry
+ *
+ * @v entry		Entry
+ * @v head		List head
+ * @v member		Name of list field within iterator's type
+ */
+#define list_check_contains_entry( entry, head, member ) do {		      \
+	assert ( list_contains_entry ( (entry), (head), member ) );	      \
+	} while ( 0 )
+
 #endif /* _IPXE_LIST_H */
diff --git a/roms/ipxe/src/include/ipxe/malloc.h b/roms/ipxe/src/include/ipxe/malloc.h
index c435a7ddb6472d2f65658272ae45..bbd6cb89850532f08f641e25cba5 100644
--- a/roms/ipxe/src/include/ipxe/malloc.h
+++ b/roms/ipxe/src/include/ipxe/malloc.h
@@ -23,7 +23,8 @@ FILE_LICENCE ( GPL2_OR_LATER );
 
 extern size_t freemem;
 
-extern void * __malloc alloc_memblock ( size_t size, size_t align );
+extern void * __malloc alloc_memblock ( size_t size, size_t align,
+					size_t offset );
 extern void free_memblock ( void *ptr, size_t size );
 extern void mpopulate ( void *start, size_t len );
 extern void mdumpfree ( void );
@@ -33,19 +34,37 @@ extern void mdumpfree ( void );
  *
  * @v size		Requested size
  * @v align		Physical alignment
+ * @v offset		Offset from physical alignment
  * @ret ptr		Memory, or NULL
  *
  * Allocates physically-aligned memory for DMA.
  *
  * @c align must be a power of two.  @c size may not be zero.
  */
-static inline void * __malloc malloc_dma ( size_t size, size_t phys_align ) {
-	void * ptr = alloc_memblock ( size, phys_align );
+static inline void * __malloc malloc_dma_offset ( size_t size,
+						  size_t phys_align,
+						  size_t offset ) {
+	void * ptr = alloc_memblock ( size, phys_align, offset );
 	if ( ptr && size )
 		VALGRIND_MALLOCLIKE_BLOCK ( ptr, size, 0, 0 );
 	return ptr;
 }
 
+/**
+ * Allocate memory for DMA
+ *
+ * @v size		Requested size
+ * @v align		Physical alignment
+ * @ret ptr		Memory, or NULL
+ *
+ * Allocates physically-aligned memory for DMA.
+ *
+ * @c align must be a power of two.  @c size may not be zero.
+ */
+static inline void * __malloc malloc_dma ( size_t size, size_t phys_align ) {
+	return malloc_dma_offset ( size, phys_align, 0 );
+}
+
 /**
  * Free memory allocated with malloc_dma()
  *
@@ -76,6 +95,17 @@ struct cache_discarder {
 #define CACHE_DISCARDERS __table ( struct cache_discarder, "cache_discarders" )
 
 /** Declare a cache discarder */
-#define __cache_discarder __table_entry ( CACHE_DISCARDERS, 01 )
+#define __cache_discarder( cost ) __table_entry ( CACHE_DISCARDERS, cost )
+
+/** @defgroup cache_cost Cache discarder costs
+ *
+ * @{
+ */
+
+#define CACHE_CHEAP	01	/**< Items with a low replacement cost */
+#define CACHE_NORMAL	02	/**< Items with a normal replacement cost */
+#define CACHE_EXPENSIVE	03	/**< Items with a high replacement cost */
+
+/** @} */
 
 #endif /* _IPXE_MALLOC_H */
diff --git a/roms/ipxe/src/include/ipxe/md5.h b/roms/ipxe/src/include/ipxe/md5.h
index c3dfeb7e01bb7fb1e0b30b3b4bb8..860bc4769013704da1cbd65cb15f 100644
--- a/roms/ipxe/src/include/ipxe/md5.h
+++ b/roms/ipxe/src/include/ipxe/md5.h
@@ -1,23 +1,72 @@
 #ifndef _IPXE_MD5_H
 #define _IPXE_MD5_H
 
-FILE_LICENCE ( GPL2_OR_LATER );
+/** @file
+ *
+ * MD5 algorithm
+ *
+ */
 
-struct digest_algorithm;
+FILE_LICENCE ( GPL2_OR_LATER );
 
 #include <stdint.h>
+#include <ipxe/crypto.h>
+
+/** An MD5 digest */
+struct md5_digest {
+	/** Hash output */
+	uint32_t h[4];
+};
 
-#define MD5_DIGEST_SIZE		16
-#define MD5_BLOCK_WORDS		16
-#define MD5_HASH_WORDS		4
+/** An MD5 data block */
+union md5_block {
+	/** Raw bytes */
+	uint8_t byte[64];
+	/** Raw dwords */
+	uint32_t dword[16];
+	/** Final block structure */
+	struct {
+		/** Padding */
+		uint8_t pad[56];
+		/** Length in bits */
+		uint64_t len;
+	} final;
+};
+
+/** MD5 digest and data block
+ *
+ * The order of fields within this structure is designed to minimise
+ * code size.
+ */
+struct md5_digest_data {
+	/** Digest of data already processed */
+	struct md5_digest digest;
+	/** Accumulated data */
+	union md5_block data;
+} __attribute__ (( packed ));
 
-struct md5_ctx {
-	u32 hash[MD5_HASH_WORDS];
-	u32 block[MD5_BLOCK_WORDS];
-	u64 byte_count;
+/** MD5 digest and data block */
+union md5_digest_data_dwords {
+	/** Digest and data block */
+	struct md5_digest_data dd;
+	/** Raw dwords */
+	uint32_t dword[ sizeof ( struct md5_digest_data ) /
+			sizeof ( uint32_t ) ];
 };
 
-#define MD5_CTX_SIZE sizeof ( struct md5_ctx )
+/** An MD5 context */
+struct md5_context {
+	/** Amount of accumulated data */
+	size_t len;
+	/** Digest and accumulated data */
+	union md5_digest_data_dwords ddd;
+} __attribute__ (( packed ));
+
+/** MD5 context size */
+#define MD5_CTX_SIZE sizeof ( struct md5_context )
+
+/** MD5 digest size */
+#define MD5_DIGEST_SIZE sizeof ( struct md5_digest )
 
 extern struct digest_algorithm md5_algorithm;
 
diff --git a/roms/ipxe/src/include/ipxe/memblock.h b/roms/ipxe/src/include/ipxe/memblock.h
new file mode 100644
index 0000000000000000000000000000000000000000..13af3e4336edaffcb3f1ec343f5be70657dc2fa8
--- /dev/null
+++ b/roms/ipxe/src/include/ipxe/memblock.h
@@ -0,0 +1,17 @@
+#ifndef _IPXE_MEMBLOCK_H
+#define _IPXE_MEMBLOCK_H
+
+/** @file
+ *
+ * Largest memory block
+ *
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <stdint.h>
+#include <ipxe/uaccess.h>
+
+extern size_t largest_memblock ( userptr_t *start );
+
+#endif /* _IPXE_MEMBLOCK_H */
diff --git a/roms/ipxe/src/include/ipxe/menu.h b/roms/ipxe/src/include/ipxe/menu.h
new file mode 100644
index 0000000000000000000000000000000000000000..993b027ea997eb1971481a466211805f22d0683d
--- /dev/null
+++ b/roms/ipxe/src/include/ipxe/menu.h
@@ -0,0 +1,49 @@
+#ifndef _IPXE_MENU_H
+#define _IPXE_MENU_H
+
+/** @file
+ *
+ * Menu selection
+ *
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <ipxe/list.h>
+
+/** A menu */
+struct menu {
+	/** List of menus */
+	struct list_head list;
+	/** Name */
+	const char *name;
+	/** Title */
+	const char *title;
+	/** Menu items */
+	struct list_head items;
+};
+
+/** A menu item */
+struct menu_item {
+	/** List of menu items */
+	struct list_head list;
+	/** Label */
+	const char *label;
+	/** Text */
+	const char *text;
+	/** Shortcut key */
+	int shortcut;
+	/** Is default item */
+	int is_default;
+};
+
+extern struct menu * create_menu ( const char *name, const char *title );
+extern struct menu_item * add_menu_item ( struct menu *menu, const char *label,
+					  const char *text, int shortcut,
+					  int is_default );
+extern void destroy_menu ( struct menu *menu );
+extern struct menu * find_menu ( const char *name );
+extern int show_menu ( struct menu *menu, unsigned int timeout_ms,
+		       const char *select, struct menu_item **selected );
+
+#endif /* _IPXE_MENU_H */
diff --git a/roms/ipxe/src/include/ipxe/mii.h b/roms/ipxe/src/include/ipxe/mii.h
new file mode 100644
index 0000000000000000000000000000000000000000..cf462418a2a65821d908969fc5e76d522efcefa5
--- /dev/null
+++ b/roms/ipxe/src/include/ipxe/mii.h
@@ -0,0 +1,87 @@
+#ifndef _IPXE_MII_H
+#define _IPXE_MII_H
+
+/** @file
+ *
+ * Media Independent Interface
+ *
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <mii.h>
+#include <ipxe/netdevice.h>
+
+struct mii_interface;
+
+/** MII interface operations */
+struct mii_operations {
+	/**
+	 * Read from MII register
+	 *
+	 * @v mii		MII interface
+	 * @v reg		Register address
+	 * @ret data		Data read, or negative error
+	 */
+	int ( * read ) ( struct mii_interface *mii, unsigned int reg );
+	/**
+	 * Write to MII register
+	 *
+	 * @v mii		MII interface
+	 * @v reg		Register address
+	 * @v data		Data to write
+	 * @ret rc		Return status code
+	 */
+	int ( * write ) ( struct mii_interface *mii, unsigned int reg,
+			  unsigned int data );
+};
+
+/** An MII interface */
+struct mii_interface {
+	/** Interface operations */
+	struct mii_operations *op;
+};
+
+/**
+ * Initialise MII interface
+ *
+ * @v mii		MII interface
+ * @v op		MII interface operations
+ */
+static inline __attribute__ (( always_inline )) void
+mii_init ( struct mii_interface *mii, struct mii_operations *op ) {
+	mii->op = op;
+}
+
+/**
+ * Read from MII register
+ *
+ * @v mii		MII interface
+ * @v reg		Register address
+ * @ret data		Data read, or negative error
+ */
+static inline __attribute__ (( always_inline )) int
+mii_read ( struct mii_interface *mii, unsigned int reg ) {
+	return mii->op->read ( mii, reg );
+}
+
+/**
+ * Write to MII register
+ *
+ * @v mii		MII interface
+ * @v reg		Register address
+ * @v data		Data to write
+ * @ret rc		Return status code
+ */
+static inline __attribute__ (( always_inline )) int
+mii_write ( struct mii_interface *mii, unsigned int reg, unsigned int data ) {
+	return mii->op->write ( mii, reg, data );
+}
+
+/** Maximum time to wait for a reset, in milliseconds */
+#define MII_RESET_MAX_WAIT_MS 500
+
+extern int mii_restart ( struct mii_interface *mii );
+extern int mii_reset ( struct mii_interface *mii );
+
+#endif /* _IPXE_MII_H */
diff --git a/roms/ipxe/src/include/ipxe/net80211.h b/roms/ipxe/src/include/ipxe/net80211.h
index 3c30f06c405f70b35fda9b999416..771872c82fb9b64c2dbfebdadcf8 100644
--- a/roms/ipxe/src/include/ipxe/net80211.h
+++ b/roms/ipxe/src/include/ipxe/net80211.h
@@ -272,7 +272,7 @@ enum net80211_crypto_alg {
 #define NET80211_MAX_RATES	16
 
 /** The maximum number of channels we allow to be configured simultaneously */
-#define NET80211_MAX_CHANNELS	32
+#define NET80211_MAX_CHANNELS	40
 
 /** Seconds we'll wait to get all fragments of a packet */
 #define NET80211_FRAG_TIMEOUT	2
diff --git a/roms/ipxe/src/include/ipxe/netdevice.h b/roms/ipxe/src/include/ipxe/netdevice.h
index e49191f4ae214268cb59246e2b13..e5dbd996b5ddd95826f677bd15bf 100644
--- a/roms/ipxe/src/include/ipxe/netdevice.h
+++ b/roms/ipxe/src/include/ipxe/netdevice.h
@@ -66,20 +66,23 @@ struct net_protocol {
 	/**
 	 * Process received packet
 	 *
-	 * @v iobuf	I/O buffer
-	 * @v netdev	Network device
-	 * @v ll_dest	Link-layer destination address
-	 * @v ll_source	Link-layer source address
+	 * @v iobuf		I/O buffer
+	 * @v netdev		Network device
+	 * @v ll_dest		Link-layer destination address
+	 * @v ll_source		Link-layer source address
+	 * @v flags		Packet flags
+	 * @ret rc		Return status code
 	 *
 	 * This method takes ownership of the I/O buffer.
 	 */
 	int ( * rx ) ( struct io_buffer *iobuf, struct net_device *netdev,
-		       const void *ll_dest, const void *ll_source );
+		       const void *ll_dest, const void *ll_source,
+		       unsigned int flags );
 	/**
 	 * Transcribe network-layer address
 	 *
-	 * @v net_addr	Network-layer address
-	 * @ret string	Human-readable transcription of address
+	 * @v net_addr		Network-layer address
+	 * @ret string		Human-readable transcription of address
 	 *
 	 * This method should convert the network-layer address into a
 	 * human-readable format (e.g. dotted quad notation for IPv4).
@@ -97,6 +100,12 @@ struct net_protocol {
 	uint8_t net_addr_len;
 };
 
+/** Packet is a multicast (including broadcast) packet */
+#define LL_MULTICAST 0x0001
+
+/** Packet is a broadcast packet */
+#define LL_BROADCAST 0x0002
+
 /**
  * A link-layer protocol
  *
@@ -125,11 +134,12 @@ struct ll_protocol {
 	 * @ret ll_dest		Link-layer destination address
 	 * @ret ll_source	Source link-layer address
 	 * @ret net_proto	Network-layer protocol, in network-byte order
+	 * @ret flags		Packet flags
 	 * @ret rc		Return status code
 	 */
 	int ( * pull ) ( struct net_device *netdev, struct io_buffer *iobuf,
 			 const void **ll_dest, const void **ll_source,
-			 uint16_t *net_proto );
+			 uint16_t *net_proto, unsigned int *flags );
 	/**
 	 * Initialise link-layer address
 	 *
@@ -178,8 +188,17 @@ struct ll_protocol {
 	uint8_t ll_addr_len;
 	/** Link-layer header length */
 	uint8_t ll_header_len;
+	/** Flags */
+	unsigned int flags;
 };
 
+/** Local link-layer address functions only as a name
+ *
+ * This flag indicates that the local link-layer address cannot
+ * directly be used as a destination address by a remote node.
+ */
+#define LL_NAME_ONLY 0x0001
+
 /** Network device operations */
 struct net_device_operations {
 	/** Open network device
@@ -586,6 +605,8 @@ netdev_rx_frozen ( struct net_device *netdev ) {
 extern void netdev_link_err ( struct net_device *netdev, int rc );
 extern void netdev_link_down ( struct net_device *netdev );
 extern int netdev_tx ( struct net_device *netdev, struct io_buffer *iobuf );
+extern void netdev_tx_err ( struct net_device *netdev,
+			    struct io_buffer *iobuf, int rc );
 extern void netdev_tx_complete_err ( struct net_device *netdev,
 				 struct io_buffer *iobuf, int rc );
 extern void netdev_tx_complete_next_err ( struct net_device *netdev, int rc );
@@ -609,7 +630,7 @@ extern int net_tx ( struct io_buffer *iobuf, struct net_device *netdev,
 		    const void *ll_source );
 extern int net_rx ( struct io_buffer *iobuf, struct net_device *netdev,
 		    uint16_t net_proto, const void *ll_dest,
-		    const void *ll_source );
+		    const void *ll_source, unsigned int flags );
 extern void net_poll ( void );
 
 /**
diff --git a/roms/ipxe/src/include/ipxe/null_entropy.h b/roms/ipxe/src/include/ipxe/null_entropy.h
new file mode 100644
index 0000000000000000000000000000000000000000..646d1a17e0f1d97992d8ce34e9e0366879be6075
--- /dev/null
+++ b/roms/ipxe/src/include/ipxe/null_entropy.h
@@ -0,0 +1,52 @@
+#ifndef _IPXE_NULL_ENTROPY_H
+#define _IPXE_NULL_ENTROPY_H
+
+/** @file
+ *
+ * Nonexistent entropy source
+ *
+ * This source provides no entropy and must NOT be used in a
+ * security-sensitive environment.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <stdint.h>
+
+#ifdef ENTROPY_NULL
+#define ENTROPY_PREFIX_null
+#else
+#define ENTROPY_PREFIX_null __null_
+#endif
+
+static inline __always_inline int
+ENTROPY_INLINE ( null, entropy_enable ) ( void ) {
+	/* Do nothing */
+	return 0;
+}
+
+static inline __always_inline void
+ENTROPY_INLINE ( null, entropy_disable ) ( void ) {
+	/* Do nothing */
+}
+
+static inline __always_inline double
+ENTROPY_INLINE ( null, min_entropy_per_sample ) ( void ) {
+	/* Actual amount of min-entropy is zero.  To avoid
+	 * division-by-zero errors and to allow compilation of
+	 * entropy-consuming code, pretend to have 1 bit of entropy in
+	 * each sample.
+	 */
+	return 1.0;
+}
+
+static inline __always_inline int
+ENTROPY_INLINE ( null, get_noise ) ( noise_sample_t *noise ) {
+
+	/* All sample values are constant */
+	*noise = 0x01;
+
+	return 0;
+}
+
+#endif /* _IPXE_NULL_ENTROPY_H */
diff --git a/roms/ipxe/src/include/ipxe/null_sanboot.h b/roms/ipxe/src/include/ipxe/null_sanboot.h
index 341a9a1d2ede601f9f444808b049..2b3a2c74d4406779161540c38b42 100644
--- a/roms/ipxe/src/include/ipxe/null_sanboot.h
+++ b/roms/ipxe/src/include/ipxe/null_sanboot.h
@@ -15,4 +15,9 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #define SANBOOT_PREFIX_null __null_
 #endif
 
+static inline __always_inline unsigned int
+SANBOOT_INLINE ( null, san_default_drive ) ( void ) {
+	return 0;
+}
+
 #endif /* _IPXE_NULL_SANBOOT_H */
diff --git a/roms/ipxe/src/include/ipxe/null_time.h b/roms/ipxe/src/include/ipxe/null_time.h
new file mode 100644
index 0000000000000000000000000000000000000000..2b72cdf509f1bd5b1e3f9581cca603d979f1aad2
--- /dev/null
+++ b/roms/ipxe/src/include/ipxe/null_time.h
@@ -0,0 +1,23 @@
+#ifndef _IPXE_NULL_TIME_H
+#define _IPXE_NULL_TIME_H
+
+/** @file
+ *
+ * Nonexistent time source
+ *
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#ifdef TIME_NULL
+#define TIME_PREFIX_null
+#else
+#define TIME_PREFIX_null __null_
+#endif
+
+static inline __always_inline time_t
+TIME_INLINE ( null, time_now ) ( void ) {
+	return 0;
+}
+
+#endif /* _IPXE_NULL_TIME_H */
diff --git a/roms/ipxe/src/include/ipxe/nvo.h b/roms/ipxe/src/include/ipxe/nvo.h
index 995afd749901bf2f120f39da78b5..487f8b3f2077a3d902e34a87c43d 100644
--- a/roms/ipxe/src/include/ipxe/nvo.h
+++ b/roms/ipxe/src/include/ipxe/nvo.h
@@ -42,6 +42,10 @@ struct nvo_block {
 	struct dhcp_options dhcpopts;
 };
 
+/** Name of non-volatile options settings block */
+#define NVO_SETTINGS_NAME "nvo"
+
+extern int nvo_applies ( struct settings *settings, struct setting *setting );
 extern void nvo_init ( struct nvo_block *nvo, struct nvs_device *nvs,
 		       size_t address, size_t len,
 		       int ( * resize ) ( struct nvo_block *nvo, size_t len ),
